require 'tor_extend'
geoipdb=["/home/seun/dat/GeoLiteCityOct.dat","/home/seun/dat/GeoLiteCityJuly.dat"]
cachedf = Tor::CachedDesc.new geoipdb
cachedf.dbconnect
cachedf.readall("/home/seun/.tor/cached-descriptors")
cachedf.readall("/home/seun/.tor/cached-descriptors.new")
tctrl= {:host=>'127.0.0.1',:port => 9051, :password=> "test1234"}
mytor=Tor::TController.new( tctrl )
entrynodes = mytor.get_entryguards + mytor.get_purposeip("guard fast")
exitnodes = mytor.get_purposeip("exit fast")
fast_relays = mytor.get_purposeip("fast !exit !guard")
puts mytor.cir_status
mytor.closeallcircuits

#<< telnet localhost 9051
#<< authenticate "controlpassword"
#<< setevents circ orconn stream

#####################################
#        GET BRIDGES #
#####################################

proxyconfig = {:type=>'polipo' ,:port=>8118,:addr=>'127.0.0.1'}
# exitnodes.count.times{|k|
bridgelist = []
20.times{|k|
    mycircuit = [ entrynodes[rand(entrynodes.count)] , fast_relays[rand(fast_relays.count)],exitnodes[k] ]
    testcir = Tor::Circuit.new(tctrl,mycircuit,nil)
    cirnum = testcir.extend
    sleep(7) if ! testcir.built?
    puts bridgelist |= testcir.get_bridges(nil,proxyconfig)   # 
    testcir.controller.closeallcircuits
}

##########################################
#    Packet spinning multiple nodes
##########################################

mytor.setconf "__DisablePredictedCircuits", 1
mytor.setconf "newcircuitperiod", 999999999
mytor.setconf "maxcircuitdirtiness", 999999999
mytor.setconf "MaxOnionsPending",0
mytor.setconf "__LeaveStreamsUnattached", 1
mytor.setconf "circuitbuildtimeout",60
mytor.closeallcircuits
puts mytor.cir_status

circuit_spin = [entrynodes[rand(entrynodes.count)], fast_relays[rand(fast_relays.count)], exitnodes[rand(exitnodes.count)] ]
cirnum = mytor.extendcir(0,circuit_spin * 5)
#<< Try to browse and Tor will leave the stream to be manually attached

mytor.newstreams.each{|z| mytor.attach_stream(z,cirnum) }
# Or use:
# Circuit.new(tctrl, circuit_spin,nil) ; Circuit.extend ; Circuit.attach_streams
sample_circuit = mytor.get_purposeip("fast exit guard")
testcir_spin2 = Tor::Circuit.new(tctrl, sample_circuit,nil)
testcir_spin = Tor::Circuit.new(tctrl, circuit_spin*5,nil)
testcir_spin.extend
testcir_spin.attach_streams

######################################################
# Write KML File
######################################################
File.open("output/torearth.kml",'w') {|torkmlfile|
    xml = cachedf.stat.genkml("ORs")
        torkmlfile.puts xml
}

File.open("output/windows-torearth.kml",'w') {|torkmlfile|
    xml = cachedf.stat.genkml("Windows ORs","WINDOWS")
	torkmlfile.puts xml
}
